module clocks(
  clkpin,
  clk,
  sdclk,
  tftclk
);

input clkpin;
output clk;
output sdclk;
output tftclk;

IBUFG clkin_buf(.O(clkin), .I(clkpin));

wire        locked_unused;
wire        clkfbout;
wire        clkfbout_buf;
wire        clkout3_unused;
wire        clkout4_unused;
wire        clkout5_unused;

PLL_BASE #(
  .BANDWIDTH              ("OPTIMIZED"),
  .CLK_FEEDBACK           ("CLKFBOUT"),
  .COMPENSATION           ("SYSTEM_SYNCHRONOUS"),
  .DIVCLK_DIVIDE          (1),
  .CLKFBOUT_MULT          (15),
  .CLKFBOUT_PHASE         (0.000),
  .CLKOUT0_DIVIDE         (2),
  .CLKOUT0_PHASE          (0.000),
  .CLKOUT0_DUTY_CYCLE     (0.500),
  .CLKOUT1_DIVIDE         (6),
  .CLKOUT1_PHASE          (0.000),
  .CLKOUT1_DUTY_CYCLE     (0.500),
  .CLKOUT2_DIVIDE         (83),
  .CLKOUT2_PHASE          (0.000),
  .CLKOUT2_DUTY_CYCLE     (0.500),
  .CLKIN_PERIOD           (20.000),
  .REF_JITTER             (0.010))
pll_base_inst(
  // Output clocks
  .CLKFBOUT              (clkfbout),
  .CLKOUT0               (clkout0),
  .CLKOUT1               (clkout1),
  .CLKOUT2               (clkout2),
  .CLKOUT3               (clkout3_unused),
  .CLKOUT4               (clkout4_unused),
  .CLKOUT5               (clkout5_unused),
  .LOCKED                (locked_unused),
  .RST                   (1'b0),
   // Input clock control
  .CLKFBIN               (clkfbout_buf),
  .CLKIN                 (clkin)
);


// Output buffering
//-----------------------------------
BUFG clkf_buf(   .O(clkfbout_buf), .I(clkfbout));
BUFG clkout1_buf(.O(clk),          .I(clkout0));
BUFG clkout2_buf(.O(sdclk),        .I(clkout1));
BUFG clkout3_buf(.O(tftclk),       .I(clkout2));

endmodule
